import numpy as np
import matplotlib.pyplot as plt
from math import *
from scipy import integrate
from signals import *
    

T = 10
def f(t):
    return rect(0.5*T,T,t+1)

def H(omega):
    ReH = 1./(1+omega)
    ImH = 0
    return ReH, ImH

plotsignal(f,-2.5*T,2.5*T,10000)
plt.show()

N = 50
omega0 = 2*pi/T
ReF = np.zeros(2*N+1)
ImF = np.zeros(2*N+1)
RenewF = np.zeros(2*N+1)
ImnewF = np.zeros(2*N+1)
ModuleF = np.zeros(2*N+1)
ArgF = np.zeros(2*N+1)
ak   = np.zeros(N+1)
bk   = np.zeros(N+1)
ck   = np.zeros(N+1)
phik = np.zeros(N+1)
EF = 0.
Ef = integrate.quad(lambda t: f(t)*f(t), -0.5*T, 0.5*T)[0] / T
for k in range(-N,N+1):
    kv = k+N
    ReF[kv] = integrate.quad(lambda t:  f(t)*cos(k*omega0*t), -0.5*T, 0.5*T)[0] / T
    ImF[kv] = integrate.quad(lambda t: -f(t)*sin(k*omega0*t), -0.5*T, 0.5*T)[0] / T
    ReH, ImH = H(k*omega0)
    RenewF[kv] = ReF[kv]*ReH - ImF[kv]*ImH
    ImnewF[kv] = ReF[kv]*ImH + ImF[kv]*ReH
    ModuleF[kv] = sqrt(ReF[kv]*ReF[kv]+ImF[kv]*ImF[kv])
    ArgF[kv] = atan2(ImF[kv],ReF[kv])
    EF = EF + ModuleF[kv]*ModuleF[kv]
    
print(Ef,EF,(Ef-EF)/Ef)

fig, ((module, argument),( modes, recons)) = plt.subplots(2, 2)
fig.suptitle('Fourier coefficients')
module.bar(np.linspace(-omega0*N,omega0*N,2*N+1),ModuleF, width = 0.1, color = 'red')
module.set_title('Module')
module.set(xlabel='omega_k', ylabel='Module')
argument.bar(np.linspace(-omega0*N,omega0*N,2*N+1),ArgF, width = 0.1, color = 'red')
argument.set_title('Argument')
argument.set(xlabel='omega_k', ylabel='Argument')



Nplot = 1000
tplot = np.linspace(-0.5*T,0.5*T,Nplot);
yplot = np.zeros(Nplot);
fplot = np.zeros(Nplot);
modeplot = np.zeros(Nplot);

for j in range(0,Nplot):
    fplot[j] = f(tplot[j])

recons.plot(tplot,fplot)

for j in range(0,Nplot):
    yplot[j] = ReF[N]
    
for k in range(1,N):
    ak[k]   =  2*ReF[N+k]
    bk[k]   = -2*ImF[N+k]
    ck[k]   = sqrt(ak[k]*ak[k]+bk[k]*bk[k])
    phik[k] = atan2(ak[k],bk[k])
    print(ak[k],bk[k],ReF[N+k],ImF[N+k])
    for j in range(0,Nplot):
        modeplot[j] = ck[k]*sin(k*omega0*tplot[j]+phik[k]);
        yplot[j] = yplot[j] + ck[k]*sin(k*omega0*tplot[j]+phik[k])
    modes.plot(tplot,modeplot)

recons.plot(tplot,yplot)

for j in range(0,Nplot):
    yplot[j] = ReF[N]
    
for k in range(1,N):
    ak[k]   =  2*RenewF[N+k]
    bk[k]   = -2*ImnewF[N+k]
    ck[k]   = sqrt(ak[k]*ak[k]+bk[k]*bk[k])
    phik[k] = atan2(ak[k],bk[k])
    print(ak[k],bk[k],ReF[N+k],ImF[N+k])
    for j in range(0,Nplot):
        yplot[j] = yplot[j] + ck[k]*sin(k*omega0*tplot[j]+phik[k])

recons.plot(tplot,yplot)


plt.show()
